Bug 447738 - Review Request: libzypp - ZYpp is a Linux software management engine
Review Request: libzypp - ZYpp is a Linux software management engine
Status: CLOSED DUPLICATE of bug 729200
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Debarshi Ray
Fedora Extras Quality Assurance
: Reopened
Depends On: 442714
Blocks: 447740 458254
  Show dependency treegraph
 
Reported: 2008-05-21 10:47 EDT by Lorenzo Villani
Modified: 2011-08-09 06:04 EDT (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-08-09 06:04:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
debarshir: fedora‑review?


Attachments (Terms of Use)

  None (edit)
Description Lorenzo Villani 2008-05-21 10:47:38 EDT
Spec URL: http://rpm.binaryhelix.org/SPECS/libs/libzypp.spec
SRPM URL: http://rpm.binaryhelix.org/SRPMS/libzypp-4.24.24-1.fc9.src.rpm

Description:
ZYpp is a Linux software management engine and open source project sponsored
by Novell that powers products like YaST, ZYpper and Zenworks with a powerful
dependency resolver and a convenient package management API.
This package contains the package management library.
Comment 1 Terje Røsten 2008-05-21 16:40:15 EDT
I can't build: 

sat-solver-devel is needed by libzypp-4.24.24-1.fc10.i386

Do have a sat-solver-devel package available somewhere?

Comment 2 Terje Røsten 2008-05-21 16:56:18 EDT
There it was, bz #442714. 
Comment 3 James Bowes 2008-06-09 08:58:44 EDT
Building on x86_64 gives the following error during rpmbuild:

error: Installed (but unpackaged) file(s) found:
   /usr/lib/zypp/zypp-query-pool
Comment 4 Lorenzo Villani 2008-06-09 13:52:24 EDT
Spec URL: http://rpm.binaryhelix.org/SPECS/libs/libzypp.spec
SRPM URL: http://rpm.binaryhelix.org/SRPMS/libzypp-5.0.0.0-2.fc9.src.rpm

* Mon Jun 09 2008 Lorenzo Villani <lvillani@binaryhelix.net> - 5.0.0.0-2
- Version bump (source checkout updated)
Comment 5 Lorenzo Villani 2008-06-09 13:54:35 EDT
Can you try to build against this release, please? I don't have an x86_64
machine to test it, however I'm going to try a scratch build with koji against
dist-f10
Comment 6 Lorenzo Villani 2008-06-19 14:53:51 EDT
Spec URL: http://rpm.binaryhelix.org/SPECS/libs/libzypp.spec
SRPM URL: http://rpm.binaryhelix.org/SRPMS/libzypp-5.0.0.0-3.fc9.src.rpm

* Thu Jun 19 2008 Lorenzo Villani <lvillani@binaryhelix.net> - 5.0.0.0-3
- Using %%cmake properly
Comment 7 Lorenzo Villani 2008-07-05 08:43:11 EDT
Spec URL: http://rpm.binaryhelix.org/SPECS/libs/libzypp.spec
SRPM URL: http://rpm.binaryhelix.org/SRPMS/libzypp-4.26.24.7-1.fc9.src.rpm

%changelog
* Sat Jul  5 2008 Lorenzo Villani <lvillani@binaryhelix.net> - 4.26.24.7-1
- Aligned to upstream stable version (this implies a downgrade but the package isn't
  in repositories yet, so...)

Comment 8 Lorenzo Villani 2008-07-05 09:59:59 EDT
Spec URL: http://rpm.binaryhelix.org/SPECS/libs/libzypp.spec
SRPM URL: http://rpm.binaryhelix.org/SRPMS/libzypp-4.26.24.7-2.fc9.src.rpm

* Sat Jul  5 2008 Lorenzo Villani <lvillani@binaryhelix.net> - 4.26.24.7-2
- Added sat-solver-static to BR
Comment 9 Lorenzo Villani 2008-08-07 06:39:42 EDT
Spec URL: http://omploader.org/vbm84/fedora-package-config-zypper.spec
SRPM URL: http://omploader.org/vbm85/libzypp-4.27.24.0-1.fc9.src.rpm

- New upstream release
Comment 10 Lorenzo Villani 2008-08-07 11:09:11 EDT
SPEC URL: http://omploader.org/vbnAy/libzypp.spec
SRPM URL: http://omploader.org/vbnA1/libzypp-4.27.24.1-1.fc9.src.rpm

* Thu Aug  7 2008 Lorenzo Villani <lvillani@binaryhelix.net> - 4.27.24.1-1
- 4.27.24.1
Comment 11 Debarshi Ray 2008-10-22 01:12:54 EDT
MUST Items: 

xx - rpmlint is unclean on SRPM
    + [rishi@freebook SRPMS]$ rpmlint libzypp-4.27.24.1-1.fc9.src.rpm 
      libzypp.src: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 10)
      1 packages and 0 specfiles checked; 0 errors, 1 warnings.
      [rishi@freebook SRPMS]$ 

OK - follows Naming Guidelines
OK - spec file is named as %{name}.spec

xx - package does not meet Packaging Guidelines
    + http://en.opensuse.org/Libzypp/ seems a better choice for the URL tag.
    + The Source0 tag should have a valid URL pointing to the upstream release
      tarball. This is an important requirement. In case upstream does not
      provide any such tarball, the Spec should have a comment above the
      Source0 tag describing how the sources were obtained to create the
      package. See:
      https://fedoraproject.org/wiki/Packaging/SourceURL
    + Could you throw some light on why it is a problem to build the language
      bindings on Fedora? Is it because of the ruby-rpm breakage in Rawhide?
    + It is not really necessary to create %{_target_platform}. See:
      http://fedoraproject.org/wiki/Packaging/cmake#Specfile_Usage
    + To preserve timestamps you could consider using:
      make install INSTALL="%{__install} -p" DESTDIR=%{buildroot}
    + You could consider shipping COPYING and TODO as %doc. What about the
      doc/persistency-concept.txt and Doxygen documentation?
    + There libzypp package does not own the %{_libdir}/zypp and
      %{_datadir}/zypp directories, which it should. See:
      https://fedoraproject.org/wiki/Packaging/UnownedDirectories
    + Since the .desktop file has a MimeType key, and you are installing icons
      in %{_datadir}/icons/hicolor, you need to use the appropriate scriptlets.
      See:
      https://fedoraproject.org/wiki/Packaging/ScriptletSnippets#desktop-database
      and
      https://fedoraproject.org/wiki/Packaging/ScriptletSnippets#GTK.2B_icon_cache
    + Some of the names in this package contain terms (like package-manager)
      which can be considered too generic. Has this been discussed elsewhere?

OK - license meets Licensing Guidelines
OK - License field meets actual license
OK - upstream license file included in %doc
OK - spec file uses American English
OK - spec file is legible

?? - sources might not match upstream sources
    + As noted earlier, please document how the sources were obtained. Place a
      comment above the Source0 tag for this.

xx - package does not build successfully
    + Checking for unpackaged file(s): /usr/lib/rpm/check-files /var/tmp/libzypp-4.27.24.1-1.fc9-root-rishi
      error: Installed (but unpackaged) file(s) found:
         /usr/lib/zypp/zypp-query-pool
      The tools/registration/CMakeLists.txt file has hard-coded 'lib' as the
      destination of zypp-query-pool. On 64-bit systems it should be 'lib64'.
      You could use sed to replace 'lib' with the value of %{_lib}.

?? - ExcludeArch not needed

?? - missing build dependencies
    + Can not verify because package fails to build.

OK - no locales
OK - %post and %postun invoke ldconfig
OK - package is not relocatable

xx - missing dependency on package that creates directory
    + The libzypp package should have a 'Requires: hicolor-icon-theme', which
      owns the %{_datadir}/icons/hicolor directory. See:
      https://fedoraproject.org/wiki/Packaging/Guidelines#FileAndDirectoryOwnership
    + Similarly, the -devel subpackage should have a 'Requires: cmake'.

OK - no duplicates in %file
OK - file permissions set properly
OK - %clean present
OK - macros used consistently
OK - contains code and permissable content
OK - -doc is not needed
OK - contents of %doc does not affect the runtime
OK - header files in -devel
OK - no static libraries

xx - missing dependency for pkgconfig files
    + The -devel package should have a 'Requires: pkgconfig' since it provides
      a .pc file.

OK - library files without suffix in -devel
OK - -devel requires base package
OK - no libtool archives

xx - %{name}.desktop file not installed properly
    + You should use desktop-file-install or desktop-file-validate if the
      package installs a .desktop file and add a
      'BuildRequires: desktop-file-utils'. See:
      https://fedoraproject.org/wiki/Packaging/Guidelines#Desktop_files

OK - does not own files or directories owned by other packages
OK - buildroot correctly prepped
OK - all file names valid UTF-8

SHOULD Items:

xx - upstream does not provide license text
    + It would be nice if upstream could provide the text of the GPLv2 in a
      separate file.

xx - no translations for description and summary

xx - package does not build in mock successfully
    + It needs sat-solver which is not yet in the repository.

?? - package builds on all supported architectures

?? - package functions as expected
    + Other components of the Zypper stack are needed to verify functionality.

xx - scriptlets are missing
    + As noted above, required scriptlets are missing.

OK - subpackages other than -devel are not needed
OK - pkgconfig files in -devel
OK - no file dependencies
Comment 12 Lorenzo Villani 2008-10-29 14:21:19 EDT
I'm pinging upstream to see if there are plans to port the ZYpp stack to rpm 4.6.
Comment 13 Debarshi Ray 2008-11-11 12:52:17 EST
(In reply to comment #12)

> I'm pinging upstream to see if there are plans to port the ZYpp stack to rpm
> 4.6.

Any response?
Comment 14 Debarshi Ray 2008-12-28 12:17:12 EST
Ping?
Comment 15 Christoph Wickert 2008-12-28 12:41:20 EST
BTW: Please remove the "ZYpp is a" from the summary tag, just "Linux software management engine" or "A Linux software management engine" is fine too.
Comment 16 Lorenzo Villani 2008-12-28 19:54:30 EST
(In reply to comment #13)
> 
> Any response?
>
They applied my patches to sat-solver (in SVN trunk/ - not in stable releases, yet) but still working on libzypp and zypper, we'll have to wait more...
Comment 17 Lorenzo Villani 2008-12-28 20:10:59 EST
(In reply to comment #15)
> BTW: Please remove the "ZYpp is a" from the summary tag, just "Linux software
> management engine" or "A Linux software management engine" is fine too.

SPEC URL: http://fedorapeople.org/gitweb?p=arbiter/public_git/rpm.git;a=blob;f=libs/libzypp/libzypp.spec;hb=HEAD
SRPM URL: http://fedorapeople.org/~arbiter/srpm/libzypp-4.28.24.1-1.fc10.src.rpm

* Mon Dec 29 2008 Lorenzo Villani <lvillani@binaryhelix.net> - 4.28.24.1-1
- 4.28.24.1
- trivial fix to Summary
Comment 19 Lorenzo Villani 2009-01-26 09:26:59 EST
Closing the request until upstream makes the necessary changes to libzypp to support RPM 4.6.
Comment 20 Michal Schmidt 2009-09-02 13:20:50 EDT
Lorenzo,
the bug "ZYpp stack and RPM 4.6.0" https://bugzilla.novell.com/show_bug.cgi?id=444211 is CLOSED FIXED. Is there something else blocking this review now?
Comment 21 Lorenzo Villani 2009-12-16 12:38:18 EST
SPEC: http://gitorious.org/lvillani/specs/blobs/master/zypp/libzypp/libzypp.spec
SRPM: http://fedorapeople.org/~arbiter/libzypp/

Notes:
- reopening: the whole ZYpp stack is now usable with rpm >= 4.6.0
- rpmlint:
[lvillani@enterprise SRPMS]$ rpmlint ../RPMS/x86_64/libzypp{,-devel,-debuginfo}-6.28.0-1.fc12.x86_64.rpm ../SRPMS/libzypp-6.28.0-1.fc12.src.rpm ../specs/zypp/libzypp/libzypp.spec 
libzypp-devel.x86_64: W: no-documentation
4 packages and 1 specfiles checked; 0 errors, 1 warnings.
Comment 22 Rahul Sundaram 2010-05-22 15:59:44 EDT
can't build it in Fedora 13

---

[ 80%] Building CXX object zypp/CMakeFiles/zypp.dir/sat/SolvIterMixin.cc.o
cd /home/sundaram/work/rpmbuild/BUILD/libzypp-6.28.0/zypp && /usr/bin/c++   -Dzypp_EXPORTS -D_FILE_OFFSET_BITS=64 -DVERSION=\"6.28.0\" -D_RPM_4_4_COMPAT -DLOCALEDIR=\"/usr/share/locale\" -DTEXTDOMAIN=\"zypp\" -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -m32 -march=i686 -mtune=atom -fasynchronous-unwind-tables  -fPIC -g -Wall -Werror=format-security -Woverloaded-virtual -Wnon-virtual-dtor -Wl,-as-needed -fPIC -I/home/sundaram/work/rpmbuild/BUILD/libzypp-6.28.0 -I/usr/include/rpm -I/usr/include/hal -I/usr/include/dbus-1.0 -I/usr/lib/dbus-1.0/include -I/usr/include/libxml2 -I/home/sundaram/work/rpmbuild/BUILD/libzypp-6.28.0/zypp   -DZYPP_BASE_LOGGER_LOGGROUP=\"satsolver\" -o CMakeFiles/zypp.dir/sat/SolvIterMixin.cc.o -c /home/sundaram/work/rpmbuild/BUILD/libzypp-6.28.0/zypp/sat/SolvIterMixin.cc
/usr/include/satsolver/pool.h: In member function 'std::string zypp::sat::Solvable::lookupStrAttribute(const zypp::sat::SolvAttr&, const zypp::Locale&) const':
/usr/include/satsolver/pool.h:226: error: too few arguments to function 'const char* solvable_lookup_str_lang(Solvable*, Id, const char*, int)'
/home/sundaram/work/rpmbuild/BUILD/libzypp-6.28.0/zypp/sat/Solvable.cc:179: error: at this point in file
make[2]: *** [zypp/CMakeFiles/zypp.dir/sat/Solvable.cc.o] Error 1
make[2]: *** Waiting for unfinished jobs....
make[2]: Leaving directory `/home/sundaram/work/rpmbuild/BUILD/libzypp-6.28.0'
make[1]: *** [zypp/CMakeFiles/zypp.dir/all] Error 2
make[1]: Leaving directory `/home/sundaram/work/rpmbuild/BUILD/libzypp-6.28.0'
make: *** [all] Error 2
error: Bad exit status from /var/tmp/rpm-tmp.tv5ycL (%build)
Comment 23 Susi Lehtola 2011-08-09 06:04:35 EDT
No action in bug for over a year, closing.

*** This bug has been marked as a duplicate of bug 729200 ***

Note You need to log in before you can comment on or make changes to this bug.